"use strict";Object.defineProperty(exports,"__esModule",{value:true});const http=require("http");const http_1=require("./instrumentations/http");const logger_1=require("./logger");const metrics_1=require("./metrics");const transaction_1=require("./transaction");const wrapper_1=require("./wrapper");const config_1=require("./config");const async_1=require("./async");const dripstat_server_1=require("./dripstat_server");const instr_loader_1=require("./instrumentations/discovery/instr_loader");const TRANSACTION_CONTEXT_KEY="__agent__";const TRANSACTION_KEY="___transaction___";const ports=[];wrapper_1.wrapMethod(http.Server.prototype,"server listen",["listen"],function(listen){return function(){if(arguments){ports.push(arguments[0])}return listen.apply(this,arguments)}});class Agent{constructor(config){this.config=config;this.metrics={};this.instrumentations=[new http_1.HttpInstrumentation];this.discoverInstrumentations=instr_loader_1.default;this.initiatedInstrumentations=new Set;this.customInstrumentations=[]}initialize(){for(const instr of this.instrumentations){instr.initialize(null)}this.patchImporter();this.reportMetrics()}newWebTransaction(req,resp){const ctx={};const asyncId=async_1.storeAsyncId(ctx);const transaction=new transaction_1.WebTransaction(asyncId,this.config);transaction.initialize(req);ctx[TRANSACTION_CONTEXT_KEY]=transaction;req[TRANSACTION_KEY]=transaction;if(resp)resp[TRANSACTION_KEY]=transaction;return transaction}getExistingWebTransaction(reqOrResp){if(reqOrResp){const trans=reqOrResp[TRANSACTION_KEY];if(trans){return trans}}const asyncCtx=async_1.getAsyncContext();if(!asyncCtx){return null}return asyncCtx[TRANSACTION_CONTEXT_KEY]}finish(transaction){async_1.clearAsyncId(transaction.asyncId);if(transaction.finished){logger_1.agentLogger.warn("Transaction already finished")}transaction.finished=true;const transTimer=transaction.timers[transaction_1.TRANSACTION_TIMER];transTimer.isError=transaction.isError;transTimer.stop();this.addMetrics(transaction)}addCustomInstrumentation(instr){instr.initialize(null);this.customInstrumentations.push(instr)}patchImporter(){const that=this;const Module=require("module");let resolvedName=null;wrapper_1.wrapMethod(Module,"Module",["_resolveFilename"],function(resolve){return function(){return resolvedName=resolve.apply(this,arguments)}});wrapper_1.wrapMethod(Module,"Module",["_load"],function(load){return function(file){const res=load.apply(this,arguments);that.onModuleLoad(res,file,resolvedName);return res}})}onModuleLoad(nodule,name,resolvedName){this.tryInitializeInstrumentation(name,this.discoverInstrumentations[name],nodule)}tryInitializeInstrumentation(moduleName,instr,nodule){if(this.initiatedInstrumentations.has(moduleName)){return}const that=this;logger_1.agentLogger.debug("trying to initialize instrumentation %s",moduleName);if(!instr){return}if(this.instrumentations.indexOf(instr)>=0){logger_1.agentLogger.log("%s already initialized",moduleName);return}if(!nodule){try{nodule=require(moduleName)}catch(e){logger_1.agentLogger.log("%s cannot be imported",moduleName);return}}this.initiatedInstrumentations.add(moduleName);try{instr.initialize(nodule);that.instrumentations.push(instr);logger_1.agentLogger.log("%s initialized",moduleName)}catch(e){logger_1.agentLogger.error("error initializing %s: %s",moduleName,e)}}addMetrics(transaction){const transactionName=transaction.getName();let metricsForThisTrans=this.metrics[transactionName];if(!metricsForThisTrans){metricsForThisTrans={};this.metrics[transactionName]=metricsForThisTrans}for(const metricName in transaction.timers){let stats=metricsForThisTrans[metricName];if(!stats){stats=new metrics_1.Stats;metricsForThisTrans[metricName]=stats}const timer=transaction.timers[metricName];if(timer.isStopped()){stats.addTime(timer.time);if(timer.isError){stats.addErrors(1)}}else{logger_1.agentLogger.warn(`Unstopped timer for ${metricName}`)}}}reportMetrics(){if(!this.config.licenseKey||!this.config.appName){logger_1.agentLogger.debug(`No license key => not sending any data`);return}const s=60-(new Date).getSeconds();setTimeout(this.reportMetrics.bind(this),1e3*s);if(!ports){logger_1.agentLogger.log("No webapp ports detected, not sending metrics yet");return}if(this.dripStatServer==null){this.dripStatServer=new dripstat_server_1.DripstatServer(this.config,ports)}if(this.dripStatServer.authenticated()){this.sendData()}else{this.dripStatServer.initData(err=>{if(err){logger_1.agentLogger.error(`Error connecting to server ${err}`)}})}}sendData(){const transactionData={};const transactionSegmentsData={};for(const transactionName in this.metrics){for(const metricName in this.metrics[transactionName]){const stat=this.metrics[transactionName][metricName];if(metricName==transaction_1.TRANSACTION_TIMER){transactionData[transactionName]=stat}else{if(!transactionSegmentsData[transactionName])transactionSegmentsData[transactionName]={};transactionSegmentsData[transactionName][metricName]=stat}}}this.dripStatServer.sendMetric(transactionData,transactionSegmentsData,err=>{if(err){logger_1.agentLogger.log("Metrics sent")}else{logger_1.agentLogger.log(`Error sending metrics ${err}`)}});this.metrics={}}}const dripAgent=new Agent(config_1.getConfig());dripAgent.initialize();exports.default=dripAgent;