"use strict";Object.defineProperty(exports,"__esModule",{value:true});const agent_1=require("../../agent");const wrapper_1=require("../../wrapper");const logger_1=require("../../logger");const metrics_1=require("../../metrics");const utils_1=require("./utils");class MongodbInstrumentation{initialize(nodule){const mongodbLibCollection=require("mongodb/lib/collection");const methods={bulkWrite:"",count:"",createIndex:"",createIndexes:"",deleteMany:"",deleteOne:"",distinct:"",drop:"",dropIndex:"",dropIndexes:"",find:"",findOne:"",findOneAndDelete:"",findOneAndReplace:"",findOneAndUpdate:"",geoHaystackSearch:"",geoNear:"",group:"",indexes:"",indexExists:"",indexInformation:"",insert:"",insertMany:"",insertOne:"",isCapped:"",listIndexes:"",mapReduce:"",options:"",parallelCollectionScan:"",reIndex:"",remove:"",rename:"",replaceOne:"",save:"",stats:"",update:"",updateMany:"",updateOne:"",watch:""};const that=this;for(const wrappedMethod in methods){wrapper_1.wrapMethod(mongodbLibCollection.prototype,`mongo collection ${wrappedMethod}`,[wrappedMethod],function(query){return function(){logger_1.agentLogger.debug("client query");if(!arguments){return query.apply(this,arguments)}logger_1.agentLogger.debug(`collection=${this.collectionName}`);const metric=that.metric(methods[wrappedMethod]?methods[wrappedMethod]:wrappedMethod,this.collectionName);const transaction=agent_1.default.getExistingWebTransaction();if(transaction)transaction.startTimer(metric,metrics_1.TimerType.Async);const callback=arguments[arguments.length-1];const callbackIsFunction="function"==typeof callback;if(callbackIsFunction){const wrappedCallback=function(err){logger_1.agentLogger.debug("client query callback");that.finishTransaction(transaction,metric,err);return callback.apply(this,arguments)};arguments[arguments.length-1]=wrappedCallback}const queryResp=query.apply(this,arguments);if(!callbackIsFunction&&queryResp instanceof Promise){wrapper_1.wrapPromise(queryResp,function(){that.finishTransaction(transaction,metric,false)},function(){that.finishTransaction(transaction,metric,true)})}logger_1.agentLogger.debug(`queryResp=${typeof queryResp} ${queryResp instanceof Promise?"promise":"not a promise"}`);return queryResp}})}}metric(operation,collection){return utils_1.cleanMetricName(`Mongo/${operation}/${collection}`)}finishTransaction(transaction,metric,error){logger_1.agentLogger.debug("finishing mongo");if(transaction){transaction.finishTimer(metric)}}}exports.MongodbInstrumentation=MongodbInstrumentation;const instr=new MongodbInstrumentation;exports.default=instr;