"use strict";Object.defineProperty(exports,"__esModule",{value:true});const agent_1=require("../../agent");const logger_1=require("../../logger");const wrapper_1=require("../../wrapper");const metrics_1=require("../../metrics");const utils_1=require("./utils");const async_hooks_1=require("async_hooks");class RedisInstrumentation{initialize(nodule){const that=this;logger_1.agentLogger.log("initialized redis");wrapper_1.wrapMethod(nodule,"redis module",["createClient"],function(fn){return function(port,host,options){const client=fn.apply(this,arguments);that.wrapClient(client);return client}})}wrapClient(client){const that=this;const commands=["zscan","flushall","memory","watch","hexists","incr","keys","ttl","zunionstore","echo","georadius_ro","georadiusbymember_ro","restore","subscribe","unlink","zincrby","client","randomkey","rpop","bitcount","setrange","sort","geohash","setex","zcount","sinter","decr","incrbyfloat","publish","hincrbyfloat","mget","time","zrevrank","decrby","geoadd","geopos","zremrangebyrank","llen","mset","select","pttl","sadd","strlen","sync","expireat","hincrby","object","type","zcard","hstrlen","pfmerge","renamenx","scard","shutdown","slaveof","zrange","zrangebyscore","georadiusbymember","pfcount","scan","monitor","script","setbit","sunionstore","zremrangebyscore","bitop","bitpos","lrem","zscore","lindex","lpushx","quit","unwatch","zrevrange","psetex","role","swapdb","sismember","touch","getset","hmget","hsetnx","readwrite","zremrangebylex","exec","linsert","move","info","lastsave","ping","pubsub","save","flushdb","georadius","hgetall","srandmember","unsubscribe","blpop","cluster","expire","sscan","zlexcount","discard","sdiff","spop","evalsha","lrange","rpush","smembers","zadd","zrank","zrem","asking","latency","setnx","multi","append","debug","lset","lpush","msetnx","rename","srem","sunion","del","hscan","hvals","pfselftest","rpoplpush","smove","zinterstore","auth","bgsave","hget","sinterstore","substr","zrevrangebylex","exists","hmset","pexpire","module","bitfield","hlen","hset","host:","incrby","psubscribe","zrangebylex","dump","get","hdel","lpop","ltrim","migrate","pexpireat","post","dbsize","eval","hkeys","punsubscribe","readonly","pfadd","pfdebug","psync","replconf","restore-asking","config","getbit","getrange","sdiffstore","set","geodist","persist","rpushx","slowlog","zrevrangebyscore","bgrewriteaof","brpop","command","brpoplpush","wait"];wrapper_1.wrapMethod(client,"redis commands",commands,function(method,methodName){return function(){const transaction=agent_1.default.getExistingWebTransaction();const metric=that.metric(methodName);if(transaction)transaction.startTimer(metric,metrics_1.TimerType.Async);const asyncResource=new async_hooks_1.AsyncResource("oracle",{triggerAsyncId:async_hooks_1.executionAsyncId(),requireManualDestroy:false});for(const i in arguments){if("function"==typeof arguments[i]){const callback=arguments[i];arguments[i]=function(){if(transaction)transaction.finishTimer(metric);try{asyncResource.emitBefore();return callback.apply(this,arguments)}finally{asyncResource.emitAfter();asyncResource.emitDestroy()}}}}return method.apply(this,arguments)}})}metric(operation){return utils_1.cleanMetricName(`Redis/${operation?operation.toLowerCase():"Other"}`)}}exports.RedisInstrumentation=RedisInstrumentation;const instr=new RedisInstrumentation;exports.default=instr;