"use strict";Object.defineProperty(exports,"__esModule",{value:true});const config_1=require("./config");const fs=require("fs");const path=require("path");const util=require("util");var LogLevel;(function(LogLevel){LogLevel[LogLevel["LOG"]=0]="LOG";LogLevel[LogLevel["DEBUG"]=1]="DEBUG";LogLevel[LogLevel["WARN"]=2]="WARN";LogLevel[LogLevel["ERROR"]=3]="ERROR";LogLevel[LogLevel["TRACE"]=4]="TRACE";LogLevel[LogLevel["AUDIT"]=1e3]="AUDIT"})(LogLevel||(LogLevel={}));const MAX_LOG_FILE_SIZE=1e9;const MAX_LOG_FILES=10;let lastLogFileCheck=Date.now();class Logger{constructor(config){this.config=config;this.minLogLevel=LogLevel.WARN;if(config.logFile){this.logFile=config.logFile}else{this.logFile=path.join(process.cwd(),"dripstat.log")}this.openStream();this.setLogLevel(config.logLevel)}log(msg,...args){}debug(msg,...args){this.doLog(LogLevel.DEBUG,msg,args)}warn(msg,...args){this.doLog(LogLevel.WARN,msg,args)}error(msg,...args){this.doLog(LogLevel.ERROR,msg,args)}trace(msg,...args){this.doLog(LogLevel.TRACE,msg,args)}audit(msg,...args){this.doLog(LogLevel.AUDIT,msg,args)}doLog(level,msg,args){if(level>=this.minLogLevel||level==LogLevel.AUDIT){this.stream.write(util.format(`${(new Date).toISOString()} ${LogLevel[level]} ${msg}\n`,...args));this.checkLogFile()}}setLogLevel(level){if(!level){level="log"}switch(level.toLowerCase()){case"log":this.minLogLevel=LogLevel.LOG;break;case"debug":this.minLogLevel=LogLevel.DEBUG;break;case"warning":this.minLogLevel=LogLevel.WARN;break;case"error":this.minLogLevel=LogLevel.ERROR;break;case"trace":this.minLogLevel=LogLevel.TRACE;break;default:throw new Error(`Unknown log level ${level}`)}}checkLogFile(){if(Date.now()-lastLogFileCheck>1e3*60){lastLogFileCheck=Date.now();const stat=fs.statSync(this.logFile);if(stat.size>MAX_LOG_FILE_SIZE){for(let i=MAX_LOG_FILES;i>=0;i--){if(i==MAX_LOG_FILES){const fn=`${this.logFile}.${i}`;if(fs.existsSync(fn)){fs.unlinkSync(fn)}}else{const fn1=i==0?this.logFile:`${this.logFile}.${i}`;const fn2=`${this.logFile}.${i+1}`;if(fs.existsSync(fn1)){fs.renameSync(fn1,fn2)}}}this.openStream()}}}openStream(){this.stream=fs.createWriteStream(this.logFile,{flags:"a"});this.stream.write("----------------------------------------------------------------------------------------------------\n");this.stream.write(`Started writing log at ${new Date}`+"\n");this.stream.write("----------------------------------------------------------------------------------------------------\n");console.log(`Writing dripstat agent logs to ${this.logFile}`)}}exports.agentLogger=new Logger(config_1.getConfig());